﻿EnableExplicit
IncludeFile "VK_SHIT.pbi"



Procedure SaveAllDialogs(Token$)
	; first enum all available dialogs
	Protected NewList Dialogs.XML_MESSAGE_UNITED()
	VkGetDialogsList(Dialogs(), 99999, Token$)	
	
	; now do messages.getHistory for every found dialog, saving results into separated folder
	Protected NewList History.XML_MESSAGE_UNITED()
	
	Protected POSTHTML$
	Protected POSTCONTENT$
	Protected POSTIMAGES$
	Protected POSTDOC$
	Protected POSTMP3$
	Protected POSTVID$
	Protected POSTLINK$
	Protected POSTWALL$
	
	Protected cFolder$
	Protected cResFolder$
	
	Protected DCount
	
	ForEach Dialogs()
		DCount + 1
		PrintN("Processing dialog " + Str(DCount) + "/" + ListSize(Dialogs()) + " ... ")
		
		; prepare directories
		cFolder$ = "history\" + Str(Dialogs()\message\uid)
		cResFolder$ = "files"
		ReCreatePath(cFolder$)
		ReCreatePath(cFolder$ + "\" + cResFolder$ + "\")	
		
		; check if history needs update
		Protected LastID
		Protected Flag
		Protected FileID 			; used to detect if history is loaded for 100%
		Protected FileOffset		; stores last offset (used to continue loading)
		LastID = 0
		FileOffset = 0
		If ReadFile(9, cFolder$ + "\History.html")
			ReadStringFormat(9)
			FileID = ReadLong(9)
			Flag = ReadLong(9)

			If Flag = 0 ; must be zero
				If FileID = VkGetDialogLastMsg (Dialogs()\message\uid, Token$)
					; skip this dialog processing as backup is already actual
					PrintN("Skipped: no new messages with " + Dialogs()\message\uid)
					PrintN("")
					CloseFile(9)
					Continue
				Else
					; continue parsing from this message id
					FileOffset = ReadLong(9)
					LastID = FileID
					CloseFile(9)
				EndIf
			Else
				; flag is wrong, wipe file
				TruncateFile(9)
				CloseFile(9)
			EndIf
		EndIf
		
		PrintN("Processing dialog history...")
		PrintN("Name: " + VkResolveID(Dialogs()\message\uid, Token$))
			
		; get next part of history
		Protected HMsg = 0
		Protected HStep = 1000
		Repeat
			VkGetIMHistory (History(), Dialogs()\message\uid, Token$, HStep, FileOffset)
			FileOffset + ListSize(History())
			If ListSize(History()) = 0
				Break
			EndIf

			POSTHTML$ = ""
			If HMsg = 0 And LastID = 0
				POSTHTML$ + "<br>Contact: " + HTML_B(VkResolveID(Dialogs()\message\uid, Token$)) + "<br>"
				POSTHTML$ + "Backup started: " + FormatDate("%yyyy/%mm/%dd %hh:%ii:%ss", Date()) + "<br>"
				POSTHTML$ + "<hr><hr>"
			EndIf

			; process history data
			ForEach History()
				LastID = History()\message\mid
				HMsg + 1

				POSTCONTENT$ = ""
				POSTIMAGES$ = ""
				POSTMP3$ = ""
				POSTVID$ = ""
				POSTLINK$ = ""
				POSTDOC$ = ""
				POSTWALL$ = ""
				
				; process attached content
				; files are not downloaded if already existing
				ForEach History()\content()
					Select History()\content()\type
						Case "photo": 
							; extract image url from post data, first try larger image sizes
							; form image url
							Protected ImgURL$ = History()\content()\photo\src_xxxbig
							If ImgURL$ = #Null$
								ImgURL$ = History()\content()\photo\src_xxbig
								If ImgURL$ = #Null$
									ImgURL$ = History()\content()\photo\src_xbig
									If ImgURL$ = #Null$
										ImgURL$ = History()\content()\photo\src_big
										If ImgURL$ = #Null$
											ImgURL$ = History()\content()\photo\src_small
										EndIf
									EndIf
								EndIf
							EndIf
							
							; form image path on a disk
							Protected ImgPath$ = cFolder$  + "\" + cResFolder$  + "\" + GetFilePart(ImgURL$)
							
							If DownloadBin(ImgPath$, ImgURL$)
								; link image To html (use preview + clickable link To full file)						
								POSTIMAGES$ + HTML_A(cResFolder$ + "\" + GetFilePart(ImgPath$), HTML_IMG(cResFolder$ + "\" + GetFilePart(ImgPath$), "[img]", 120, 120))				
							Else
								PrintN( "Failed img download, url=" + ImgURL$)
							EndIf
		
							
						Case "audio": 
							POSTMP3$ + HTML_I("Audio", "color:#797979") + " (" + History()\content()\audio\artist + " — " + History()\content()\audio\title + ")<br>"
							
						Case "link": 
							POSTLINK$ + HTML_I("Url", "color:#797979") + " (" + HTML_A(History()\content()\link\url, History()\content()\link\url + " :: " + History()\content()\link\title) + ")<br>"
							
						Case "doc": 
							; form image path on a disk
							Protected DocPath$ = cFolder$ + "\" + cResFolder$ + "\" + "doc_" + History()\content()\doc\did + "." + History()\content()\doc\ext
							Protected DocURL$ = History()\content()\doc\url
							
							If DownloadBin(DocPath$, DocURL$)					
								POSTDOC$ + HTML_I("File", "color:#797979") + " (" + HTML_A(cResFolder$ + "\" + GetFilePart(DocPath$), History()\content()\doc\title) + ")<br>"
							Else
								PrintN("Failed doc download, url=" + DocURL$)
							EndIf
		
						Case "video": 
							POSTVID$ + HTML_I("Video", "color:#797979") + " (" + History()\content()\video\title + ")<br>"
						
						Case "wall":
							POSTWALL$ + HTML_I("Quote", "color:#797979") + " (" + VkResolveID(History()\content()\wall\from_id, Token$) + ") " + HTML_I(FormatDate("%yyyy/%mm/%dd %hh:%ii:%ss:", History()\content()\wall\date), "color:#797979") + "<br>"
							POSTWALL$ + History()\content()\wall\text + "<br>"
						
						Case "wall_reply":
							POSTWALL$ + HTML_I("Comment", "color:#797979") + " (" + VkResolveID(History()\content()\wall_reply\from_id, Token$) + ") " + HTML_I(FormatDate("%yyyy/%mm/%dd %hh:%ii:%ss:", History()\content()\wall_reply\date), "color:#797979") + "<br>"
							POSTWALL$ + History()\content()\wall_reply\text + "<br>"
						
						Case "sticker": 
							; ignore that shit
							
						Default
							PrintN("[???] " + History()\content()\type)
							Input()
					EndSelect
				Next
				
				If POSTIMAGES$
					POSTIMAGES$ = POSTIMAGES$ + "<br><br>"
				EndIf
				If POSTDOC$
					POSTDOC$ = "" + POSTDOC$ + "<br>"
				EndIf		
				If POSTMP3$
					POSTMP3$ = "" + POSTMP3$ + "<br>"
				EndIf
				If POSTVID$
					POSTVID$ = "" + POSTVID$ + "<br>"
				EndIf
				If POSTLINK$
					POSTLINK$ = "" + POSTLINK$ + "<br>"
				EndIf		
				If POSTWALL$
					POSTWALL$ = "" + POSTWALL$ + "<br>"
				EndIf				
				
				; compose HTML
				; separator between history messages
				POSTHTML$ + "<hr><br>"
				
				; nickname
				Protected NickColor$
				If History()\message\out
					NickColor$ = "color:#B94426"
				Else
					NickColor$ = "color:#006BB1"
				EndIf
				POSTHTML$ + HTML_B(VkResolveID(History()\message\uid, Token$), NickColor$) + " " + HTML_I(FormatDate("%yyyy/%mm/%dd %hh-%ii-%ss", History()\message\date)) + "<br>"
	
				; message text (if not empty)
				If History()\message\body
					POSTHTML$ + History()\message\body + "<br><br>"
				EndIf
				; message content
				POSTHTML$ + POSTWALL$
				POSTHTML$ + POSTIMAGES$
				POSTHTML$ + POSTDOC$
				POSTHTML$ + POSTVID$
				POSTHTML$ + POSTMP3$
				POSTHTML$ + POSTLINK$
	
			Next


			PrintN("+" + Str(ListSize(History())))
			If OpenFile(8, cFolder$ + "\History.html", #PB_File_SharedRead)
				; rewrite "header"
				WriteStringFormat(8, #PB_UTF16)
				WriteLong(8, LastID)
				WriteLong(8, 0)
				WriteLong(8, FileOffset)
				
				; jump to the end of the file and write HTML there
				FileSeek(8, Lof(8))
				WriteString(8, POSTHTML$, #PB_UTF16)
				CloseFile(8)
			EndIf
			
		ForEver
		
		
		PrintN("Finished with " + VkResolveID(Dialogs()\message\uid, Token$))
		PrintN("")
	Next
EndProcedure




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

OpenConsole("Save IM")

PrintN("[1/1. Paste your VK API access token and press enter]")
Define Token$ = Input()

SaveAllDialogs (Token$)

PrintN("DONE")
Input()


; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 1
; Folding = -----
; EnableXP
; Executable = IMSaver.exe
; CPU = 1
; SubSystem = /OPENGL
; CompileSourceDirectory
; EnableBuildCount = 7
; EnableExeConstant