﻿EnableExplicit
IncludeFile "VK_SHIT.pbi"


; Load and saves every post on some page
; RETURN:		none, all to disk or log
;				page$ used to define output folder
Procedure SavePagePosts (Token$, Page$, IgnoreReposts, Count)
	; a list to receive wall posts
	Protected NewList Posts.XML_POSTUNITED()
	
	; get wall posts data
	Protected NewList TPosts.XML_POSTUNITED()
	Protected Offset, Load
	PrintN("Loading posts XML (" + Str(Count) + " max):" )
	Repeat
		Load = 100
		If Load + Offset > Count
			Load = Count - Offset
		EndIf
		If Offset > Count Or Load = 0
			Break
		EndIf
		PrintN( "+" + Str(Load))
		
		VkGetWallPosts(TPosts(), Page$, Token$, Offset, Load, IgnoreReposts)
		If ListSize(TPosts()) = 0
			Break
		Else
			MergeLists(TPosts(), Posts())
			Offset + 100
		EndIf
	ForEver
	FreeList(TPosts())
	
	; show results
	PrintN( "Number of posts found: " + Str(ListSize(Posts())))
	
	; folder to store stuff for current page
	Protected PageFolder$ = GetPathPart(ProgramFilename()) + "walls\" + LCase(Page$)
	Protected ResFolder$ = "files"
	ReCreatePath(PageFolder$)
	ReCreatePath(PageFolder$ + "\" + ResFolder$)
	CreateFile(6, PageFolder$ + "\" + LCase(Page$) + "_wall.html", #PB_File_SharedRead)
	WriteStringFormat(6, #PB_UTF8)
	
	; loop variables
	Protected PAGEHTML$
	
	Protected POSTHTML$
	Protected POSTIMAGES$
	Protected POSTDOC$
	Protected POSTMP3$
	Protected POSTVID$
	Protected POSTLINK$
	Protected POSTPOLL$
	
	
	; load and save all wall data
	; html file is overwritten everytime this function called
	Protected Cpost 
	Protected *C.XML_POSTUNITED
	
	ForEach Posts()
		*C = @Posts()
		
		; show progress
		POSTHTML$ = ""
		; get generic page info
		If PAGEHTML$ = ""
			If *C\post\to_id < 0
				PAGEHTML$ = VkGetGroupInfoHTML (Abs(*C\post\to_id), Token$)
				PrintN("Saving group photo...")
				If VkSaveGroupPhoto (PageFolder$ + "\" + ResFolder$ + "\_ava.jpg", Abs(*C\post\to_id), Token$)
					PAGEHTML$ = HTML_A(ResFolder$ + "\" + "_ava.jpg", HTML_IMG(ResFolder$ + "\" + "_ava.jpg", "[ava]")) + "<br><br>" + PAGEHTML$
				EndIf
			Else
				PAGEHTML$ = VkGetUserInfoHTML (*C\post\to_id, Token$)
				PrintN("Saving page photo...")
				If VkSaveUserPhoto (PageFolder$ + "\" + ResFolder$ + "\_ava.jpg", *C\post\to_id, Token$)
					PAGEHTML$ = HTML_A(ResFolder$ + "\" + "_ava.jpg", HTML_IMG(ResFolder$ + "\" + "_ava.jpg", "[ava]")) + "<br><br>" + PAGEHTML$
				EndIf
			EndIf
			POSTHTML$ = PAGEHTML$ + "<hr><hr>"
		EndIf
		
		; ++
		Cpost + 1
		PrintN("Processing post: " + Str(Cpost) + ":" + Str(ListSize(Posts())))
	
		POSTHTML$ + "<hr>" + "<br><br><br>"
		
		If *C\post\from_id < 0
			; here is post from community
			POSTHTML$ + HTML_A("https://vk.com/" + LCase(Page$), HTML_B(VkResolveID(*C\post\from_id, Token$), "color:#B94426"))

			; reposts
			If *C\post\post_type = "copy"
				POSTHTML$ + " (repost from " + HTML_A("https://vk.com/wall" + *C\post\copy_owner_id + "_" + *C\post\copy_post_id, VkResolveID(*C\post\copy_owner_id, Token$), "color:#B94426") + ")"
			Else
				; add original post author if present
				If *C\post\signer_id
					POSTHTML$ + " (" + HTML_A("https://vk.com/id" + Str(*C\post\signer_id), VkResolveID(*C\post\signer_id, Token$), "color:#B94426") + ")"
				EndIf
			EndIf
			
		Else
			POSTHTML$ + HTML_A("https://vk.com/id" + Str(*C\post\from_id), HTML_B(VkResolveID(*C\post\from_id, Token$), "color:#B94426"))
		EndIf
		
		POSTHTML$ + " " + HTML_A("https://vk.com/wall" + *C\post\to_id + "_" + *C\post\id, HTML_I(FormatDate("%yyyy/%mm/%dd %hh-%ii-%ss", *C\post\date), "color:#8F8F8F")) + "<br><br>"
		
		
		If *C\post\post_type = "copy"
			If *C\post\copy_text
				POSTHTML$ + *C\post\copy_text + "<br>"
			EndIf
			POSTHTML$ + "————————————————— repost —————————————————"
			POSTHTML$ + "<br>" + *C\post\text
		Else
			POSTHTML$ + *C\post\text
		EndIf
		
		
		POSTIMAGES$ = ""
		POSTMP3$ = ""
		POSTVID$ = ""
		POSTLINK$ = ""
		POSTDOC$ = ""
		POSTPOLL$ = ""
		
		; process attached content
		; files are not downloaded if already existing
		ForEach *C\content()
			Select *C\content()\type
				Case "photo": 
					; extract image url from post data, first try larger image sizes
					; form image url
					Protected ImgURL$ = *C\content()\photo\src_xxxbig
					If ImgURL$ = #Null$
						ImgURL$ = *C\content()\photo\src_xxbig
						If ImgURL$ = #Null$
							ImgURL$ = *C\content()\photo\src_xbig
							If ImgURL$ = #Null$
								ImgURL$ = *C\content()\photo\src_big
								If ImgURL$ = #Null$
									ImgURL$ = *C\content()\photo\src_small
								EndIf
							EndIf
						EndIf
					EndIf
					
					; form image path on a disk
					Protected ImgPath$ = PageFolder$ + "\" + ResFolder$ + "\" + GetFilePart(ImgURL$)
					
					If DownloadBin(ImgPath$, ImgURL$)
						; link image To html (use preview + clickable link To full file)						
						POSTIMAGES$ + HTML_A(ResFolder$ + "\" + GetFilePart(ImgPath$), HTML_IMG(ResFolder$ + "\" + GetFilePart(ImgPath$), "(img)", 120, 120))				
					Else
						PrintN( "Failed img download, url=" + ImgURL$)
					EndIf



				Case "audio": 
					POSTMP3$ + HTML_I("Audio", "color:#797979") + " (" + *C\content()\audio\artist + " — " + *C\content()\audio\title + ")<br>"
					
				Case "link": 
					POSTLINK$ + HTML_I("Url", "color:#797979") + " (" + HTML_A(*C\content()\link\url, *C\content()\link\url + " :: " + *C\content()\link\title) + ")<br>"
					
				Case "doc": 
					; form image path on a disk
					Protected DocPath$ = PageFolder$ + "\" + ResFolder$ + "\doc_" + *C\content()\doc\did + "." + *C\content()\doc\ext
					Protected DocURL$ = *C\content()\doc\url
					
					If DownloadBin(DocPath$, DocURL$)					
						POSTDOC$ + HTML_I("File", "color:#797979") + " (" + HTML_A(ResFolder$ + "\" + GetFilePart(DocPath$), *C\content()\doc\title) + ")<br>"
					Else
						PrintN( "Failed doc download, url=" + DocURL$)
					EndIf

				Case "video": 
					POSTVID$ + HTML_I("Video", "color:#797979") + " (" + *C\content()\video\title + ")<br>"

				Case "poll":
					POSTPOLL$ = HTML_I("Poll", "color:#797979") + " (" +  HTML_B(*C\content()\poll\question) + "):<br>"
					POSTPOLL$ + VkGetWallPollHTML(*C\post\to_id, *C\content()\poll\poll_id, Token$)
					
				Default
					PrintN("[???] " + *C\content()\type)
					Input()
			EndSelect
		Next
		

		If POSTIMAGES$
			POSTIMAGES$ = POSTIMAGES$ + "<br><br>"
		EndIf
		If POSTDOC$
			POSTDOC$ = "" + POSTDOC$ + "<br>"
		EndIf		
		If POSTMP3$
			POSTMP3$ = "" + POSTMP3$ + "<br>"
		EndIf
		If POSTVID$
			POSTVID$ = "" + POSTVID$ + "<br>"
		EndIf
		If POSTLINK$
			POSTLINK$ = "" + POSTLINK$ + "<br>"
		EndIf		
		If POSTPOLL$
			POSTPOLL$ = "" + POSTPOLL$ + "<br>"
		EndIf	
		
		; compose HTML
		POSTHTML$ + "<br><br>"
		POSTHTML$ + POSTIMAGES$
		POSTHTML$ + POSTPOLL$
		POSTHTML$ + POSTDOC$
		POSTHTML$ + POSTVID$
		POSTHTML$ + POSTMP3$
		POSTHTML$ + POSTLINK$
		
		POSTHTML$ + HTML_I("Likes: " + *C\post\likes\count +
		", Reposts: " + *C\post\reposts\count	+
		", Comments: " + *C\post\comments\count, "color:#797979")
		If *C\post\comments\count
			POSTHTML$ + "<br><br>" +  VkGetWallCommentsHTML(*C\post\to_id, *C\post\id, Token$)
			POSTHTML$ + "<br>"
		Else
			POSTHTML$ + "<br><br><br>"
		EndIf	
		
		
		; save post HTML text (if any)
		WriteString(6, POSTHTML$, #PB_UTF8)	
	Next
	CloseFile(6)
	
	PrintN("DONE")
EndProcedure



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; usage

OpenConsole("SavePageWall")


PrintN("[1/3. Paste your VK API access token and press enter]")
Define Token$ = Input()

PrintN("[2/3. Type page address (like 'durov' or 'id1' and press enter]")
PrintN("!! Warning, related folder will be overwritten !!")
Define Page$ = Input()

PrintN("[3/3. Save reposts also? (Y = yes)]")
Define NoReposts = Bool(LCase(Input()) <> "y")

SavePagePosts (Token$, Page$, NoReposts, 9999999)

Input()
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 249
; Folding = +-----
; EnableXP
; Executable = WallSaver.exe
; CPU = 1
; SubSystem = /OPENGL
; CompileSourceDirectory
; EnablePurifier
; EnableBuildCount = 10
; EnableExeConstant
; EnableUnicode